$Pref::ArmorPickup::MaxArmor = 200;
$Pref::ArmorPickup::DamageMultiplier = 0.5;


datablock ItemData(ArmorPickupItem)
{
  uiName = "Armor Pickup - 100";
  iconName = "";
  image = "";
  category = Weapon;
  className = Weapon;
  shapeFile = "./armor.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
    isArmorPickup = true;
    armorPickupAmount = 100;
  doColorShift = true;
  colorShiftColor = "0 0.25 1 1";
  canDrop = true;
  //hasLight = true;
  //lightType = "ConstantLight";
  //lightColor = "0 1 0";
  lightTime = -1;
  lightRadius = 10;
};

datablock ItemData(ArmorPickupGreenItem : ArmorPickupItem)
{
    uiName = "Armor Pickup - 50";
    colorShiftColor = "0.25 1 0.25 1";
    shapeFile = "./helmet.dts";
    //lightColor = "0 0 1";
    armorPickupAmount = 50;
};

datablock ItemData(ArmorPickupPurpleItem : ArmorPickupItem)
{
    uiName = "Armor Pickup - 200";
    colorShiftColor = "0.75 0 1 1";
    shapeFile = "./armorhelmet.dts";
    //lightColor = "0 0 1";
    armorPickupAmount = 200;
};

function Player::getArmorPickupLevel(%this)
{
    if(%this.pickupArmor <= 0 || %this.pickupArmor $= "")
        return 0;
    
    return %this.pickupArmor;
}

function ItemData::getArmorPickupAmount(%this)
{
    %amt = %this.armorPickupAmount;
    
    if(%this.armorPickupAmount < 0 || %this.armorPickupAmount $= "")
        %amt = 0;
    
    return %amt;
}

function Player::setArmorPickupLevel(%this,%n)
{
    if(!isObject(%this))
        return;
    
    if(%n <= 0) %n = 0;                  
    %this.pickupArmor = %n;
}

function Player::addArmorPickupLevel(%this,%n)
{
    %a = %this.getArmorPickupLevel();
    %this.setArmorPickupLevel(%a + %n);
    return;
}

registerOutputEvent("Player", "SetArmorPickupLevel", "int 0 10000 50", 0);
registerOutputEvent("Player", "AddArmorPickupLevel", "int -10000 10000 50", 0);

function ArmorPickupMultiplier()
{
    if($Pref::ArmorPickup::DamageMultiplier >= 1)
        $Pref::ArmorPickup::DamageMultiplier = 0.5;
    
    return $Pref::ArmorPickup::DamageMultiplier;
}

function ArmorPickupMax()
{
    if($Pref::ArmorPickup::MaxArmor < 0)
        $Pref::ArmorPickup::MaxArmor = 100;
    
    return $Pref::ArmorPickup::MaxArmor;
}


package armorPickup
{
  function Armor::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f)
  {
    if(%col.getClassName() $= "Item" && %col.canPickup)
    {
        if(%col.getDatablock().isArmorPickup != true)
        {
            parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f);
            return;
        }
      if(%obj.getArmorPickupLevel() <= ArmorPickupMax())
      {
        %obj.setArmorPickupLevel(%obj.getArmorPickupLevel() + %col.getDatablock().getArmorPickupAmount());
        if(%obj.getArmorPickupLevel() > ArmorPickupMax())
            %obj.setArmorPickupLevel(ArmorPickupMax());
          
          //announce(%obj.getArmorPickupLevel());
        if(isObject(%col.spawnBrick))
        {
          %col.fadeOut();
          %col.schedule(%col.spawnBrick.itemRespawnTime,fadein);
        }
        else
          %col.schedule(10,delete);
      }
      return;
    }
    parent::onCollision(%this,%obj,%col,%a,%b,%c,%d,%e,%f);
  }
    
    function Armor::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType)
    {
        if(%damageType == 6)
        {
            parent::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType);
            return;
        }
            
        if(%obj.getArmorPickupLevel() > 0)
        {
            %olddmg = %damage;
            %damage = mfloor(%damage*ArmorPickupMultiplier());
            //announce("For player" SPC %obj.client.name SPC "took damage" SPC %olddmg SPC "lowered to" SPC %damage);
            %obj.setArmorPickupLevel(%obj.getArmorPickupLevel() - %oldDmg);
            //announce(%obj.getArmorPickupLevel());
        }
        parent::Damage(%this,%obj,%sourceObject,%pos,%damage,%damageType);
    }
    
    function ItemData::onAdd(%this,%obj)
	{
        if(!%this.isArmorPickup)
        {
            parent::onAdd(%this,%obj);
            return;
        }
		%obj.schedule(5,"applyBounce");
		Parent::onAdd(%this,%obj);
	}
	function Item::applyBounce(%obj)
	{
		if(isObject(%obj.spawnBrick))
		{
			%obj.rotate = 1;
		}
	}
};
deactivatepackage(armorPickup);activatePackage(armorPickup);
